/**
 * copyright (c) 2017-2020 厦门风领科技有限公司
 * http://www.fenglinghudong.com/
 * 
 * 原色APP适配
 * zengbinsi
 * 2020-08-15 15:38:30
 */


/** Banner广告类 */
class FLBanner {

    constructor() {
        fl.log('创建Native平台banner广告');
        /** 广告样式 */
        FLBanner.style = {
            left: 0,
            top: 0,
            width: 0,
            height: 0,
            realWidth: 0,
            realHeight: 0
        };
    }

    /** 显示广告 */
    show() {

    }

    /** 隐藏广告 */
    hide() {

    }

    /** 销毁广告 */
    destroy() {

    }

    /**
     * 监听 banner 广告尺寸变化事件
     * @param {*} callback 
     */
    onResize(callback) {

    }
    
    /**
     * 取消监听 banner 广告尺寸变化事件
     * @param {*} callback 
     */
    offResize(callback) {

    }
    
    /**
     * 监听 banner 广告加载事件
     * @param {*} callback 
     */
    onLoad(callback) {

    }
    
    /**
     * 取消监听 banner 广告加载事件
     * @param {*} callback 
     */
    offLoad(callback) {

    }
    
    /**
     * 监听 banner 广告错误事件
     * @param {*} callback 
     */
    onError(callback) {

    }
    
    /**
     * 取消监听 banner 广告错误事件
     * @param {*} callback 
     */
    offError(callback) {

    }
}

/** 激励式视频广告 */
class FLRewardedVideoAd {
    constructor() {
        fl.log('创建Native平台激励式视频广告');
    }

    load() {

    }

    show() {

    }

    destroy() {

    }

    onLoad(callback) {

    }

    offLoad(callback) {

    }

    onError(callback) {

    }

    offError(callback) {

    }

    onClose(callback) {

    }

    offClose(callback) {

    }
}

/** 插屏广告 */
class FLInterstitialAd {
    constructor() {
        fl.log('创建Native平台插屏广告');
    }

    load() {

    }

    show() {

    }

    destroy() {

    }

    onLoad(callback) {

    }

    offLoad(callback) {

    }

    onError(callback) {

    }

    offError(callback) {

    }

    onClose(callback) {

    }

    offClose(callback) {

    }
}

/** 原生广告 */
class FLNativeAd {
    constructor() {
        fl.log('创建Native平台原生广告');
    }
    
    /**
     * 获取广告数据， 成功回调 onLoad， 失败回调 onError
     * http: //cdofs.oppomobile.com/cdo-activity/static/201810/26/quickgame/documentation/ad/native-ad.html
     */
    load() {

    }

    show() {

    }

    destroy() {

    }

    /**
     * 设置广告加载成功回调
     * http: //cdofs.oppomobile.com/cdo-activity/static/201810/26/quickgame/documentation/ad/native-ad.html
     * @param {*} callback 
     */
    onLoad(callback) {

    }

    offLoad(callback) {

    }

    onError(callback) {

    }

    offError(callback) {

    }

    onClose(callback) {

    }

    offClose(callback) {

    }

    /**
     * 上报广告曝光， 一个广告只有一次上报有效， adId 为 load 方法获取的广告数据的 adId 字段
     * http: //cdofs.oppomobile.com/cdo-activity/static/201810/26/quickgame/documentation/ad/native-ad.html
     * @param {*} data 
     */
    reportAdShow(data) {

    }

    /**
     * 上报广告点击， 一个广告只有一次上报有效， adId 为 load 方法获取的广告数据的 adId 字段
     * http: //cdofs.oppomobile.com/cdo-activity/static/201810/26/quickgame/documentation/ad/native-ad.html
     * @param {*} data 
     */
    reportAdClick(data) {

    }
}

/** 盒子广告 */
class FLGameBoxAd {
    constructor() {
        fl.log('创建Native平台盒子广告');
    }

    /**
     * 获取广告数据
     * https: //q.qq.com/wiki/develop/game/API/ad/AppBox.html
     */
    load() {
        
    }

    show() {

    }

    destroy() {

    }

    onError(callback) {

    }

    offError(callback) {

    }

    onClose(callback) {

    }

    offClose(callback) {

    }
}



window.fl = window.fl || {};
fl.adapter = fl.adapter || {};


if (fl.adapter.isNative) {
    console.log('fl.framework ===>>>', '适配原生APP平台');

    /** 监听Java或者OC传递过来的信息 */
    window.postMessageToTSGame = (data)=>{
        fl.log('native call TS function:', data);
    };

    fl.adapter.onShow = (callback) => {return fl.log('调用Native平台的onShow函数。')};
    fl.adapter.offShow = (callback) => {return fl.log('调用Native平台的offShow函数。')};
    fl.adapter.onHide = (callback) => {return fl.log('调用Native平台的onHide函数。')};
    fl.adapter.offHide = (callback) => {return fl.log('调用Native平台的offHide函数。')};



    /** 更新宿主App */
    fl.adapter.updateApp = () => {return fl.log('调用Native平台的updateApp函数。')};
    /** 获取启动参数 */
    fl.adapter.getLaunchOptionsSync = () => {return fl.log('调用Native平台的getLaunchOptionsSync函数。')};
    // 小游戏跳转
    fl.adapter.navigateToMiniProgram = fl.adapter.navigateToMiniProgram || (() => {return fl.log('调用Native平台的navigateToMiniProgram函数。')});
    /** 设置屏幕常亮 */
    fl.adapter.setKeepScreenOn = () => {return fl.log('调用Native平台的setKeepScreenOn函数。')};






    // 广告
    /** 创建Banner广告 */
    fl.adapter.createBannerAd = (data) => {
        return new FLBanner();
    };

    /** 创建激励式视频广告 */
    fl.adapter.createRewardedVideoAd = (data) => {
        return new FLRewardedVideoAd();
    };

    /** 创建插屏广告 */
    fl.adapter.createInterstitialAd = (data) => {
        return new FLInterstitialAd(data);
    };

    /** 创建原生广告 */
    fl.adapter.createNativeAd = (data) => {
        return new FLNativeAd(data);
    };

    /** 创建盒子广告 */
    fl.adapter.createAppBox = (data) => {
        return new FLGameBoxAd(data);
    };




    // 转发分享

    /** 更新转发属性 */
    fl.adapter.updateShareMenu = (data) => {return fl.log('调用Native平台的updateShareMenu函数。')};
    /** 显示当前页面的转发按钮 */
    fl.adapter.showShareMenu = (data) => {return fl.log('调用Native平台的showShareMenu函数。')};
    /** 主动拉起转发，进入选择通讯录界面 */
    fl.adapter.shareAppMessage = (data) => {return fl.log('调用Native平台的shareAppMessage函数。')};
    /** 监听用户点击右上角菜单的「转发」按钮时触发的事件 */
    fl.adapter.onShareAppMessage = (callback) => {return fl.log('调用Native平台的onShareAppMessage函数。')};
    /** 获取转发详细信息 */
    fl.adapter.getShareInfo = (data) => {return fl.log('调用Native平台的getShareInfo函数。')};








    fl.adapter.login = ()=>{return fl.log('调用Native平台的login函数。')};
    fl.adapter.checkSession = ()=>{return fl.log('调用Native平台的checkSession函数。')};
    fl.adapter.authorize = ()=>{return fl.log('调用Native平台的authorize函数。')};
    fl.adapter.getSystemInfoSync = ()=>{return fl.log('调用Native平台的getSystemInfoSync函数。')};
    fl.adapter.getSystemInfo = ()=>{return fl.log('调用Native平台的getSystemInfo函数。')};
    fl.adapter.getBatteryInfoSync = ()=>{return fl.log('调用Native平台的getBatteryInfoSync函数。')};
    fl.adapter.getNetworkType = ()=>{return fl.log('调用Native平台的getNetworkType函数。')};
    fl.adapter.onNetworkStatusChange = ()=>{return fl.log('调用Native平台的onNetworkStatusChange函数。')};
    fl.adapter.vibrateShort = ()=>{return fl.log('调用Native平台的vibrateShort函数。')};
    fl.adapter.vibrateLong = ()=>{return fl.log('调用Native平台的vibrateLong函数。')};
    fl.adapter.showToast = ()=>{return fl.log('调用Native平台的showToast函数。')};
    fl.adapter.showModal = ()=>{return fl.log('调用Native平台的showModal函数。')};
    fl.adapter.getMenuButtonBoundingClientRect = ()=>{return fl.log('调用Native平台的getMenuButtonBoundingClientRect函数。')};
    fl.adapter.getGameRecorderManager = ()=>{return fl.log('调用Native平台的getGameRecorderManager函数。')};
    fl.adapter.setClipboardData = ()=>{return fl.log('调用Native平台的setClipboardData函数。')};
    fl.adapter.getClipboardData = ()=>{return fl.log('调用Native平台的getClipboardData函数。')};
    fl.adapter.createBlockAd = ()=>{return fl.log('调用Native平台的createBlockAd函数。')};
    fl.adapter.hideShareMenu = ()=>{return fl.log('调用Native平台的hideShareMenu函数。')};
    fl.adapter.offShareAppMessage = ()=>{return fl.log('调用Native平台的offShareAppMessage函数。')};
    fl.adapter.setStorageSync = ()=>{return fl.log('调用Native平台的setStorageSync函数。')};
    fl.adapter.setStorage = ()=>{return fl.log('调用Native平台的setStorage函数。')};
    fl.adapter.getStorageSync = ()=>{return fl.log('调用Native平台的getStorageSync函数。')};
    fl.adapter.getStorage = ()=>{return fl.log('调用Native平台的getStorage函数。')};
    fl.adapter.removeStorageSync = ()=>{return fl.log('调用Native平台的removeStorageSync函数。')};
    fl.adapter.removeStorage = ()=>{return fl.log('调用Native平台的removeStorage函数。')};
    fl.adapter.clearStorageSync = ()=>{return fl.log('调用Native平台的clearStorageSync函数。')};
    fl.adapter.clearStorage = ()=>{return fl.log('调用Native平台的clearStorage函数。')};
    fl.adapter.loadSubpackage = ()=>{return fl.log('调用Native平台的loadSubpackage函数。')};
    fl.adapter.getUpdateManager = ()=>{return fl.log('调用Native平台的getUpdateManager函数。')};
    fl.adapter.onMoreGamesModalClose = ()=>{return fl.log('调用Native平台的onMoreGamesModalClose函数。')};
    fl.adapter.onNavigateToMiniProgram = ()=>{return fl.log('调用Native平台的onNavigateToMiniProgram函数。')};
    fl.adapter.setEnableDebug = ()=>{return fl.log('调用Native平台的setEnableDebug函数。')};
    fl.adapter.hasShortcutInstalled = ()=>{return fl.log('调用Native平台的hasShortcutInstalled函数。')};
    fl.adapter.installShortcut = ()=>{return fl.log('调用Native平台的installShortcut函数。')};
}