/**
 * copyright (c) 2017-2021 厦门风领科技有限公司
 * http://www.fengling.cn/
 * 
 * h5小游戏适配
 * zengbinsi
 * 2020-08-15 15:37:25
 */




window.fl = window.fl || {};
fl.adapter = fl.adapter || {};




if (cc.sys.isBrowser) {
    console.log('fl.framework ===>>>', '适配H5平台');
    fl.adapter.tag = "h5";
    fl.adapter.onShow = (callback) => {};
    fl.adapter.offShow = (callback) => {};
    fl.adapter.onHide = (callback) => {};
    fl.adapter.offHide = (callback) => {};



    fl.adapter.login = (data)=>{};


    /** 更新宿主App */
    fl.adapter.updateApp = () => {};
    /** 获取启动参数 */
    fl.adapter.getLaunchOptionsSync = () => {
        fl.log('在H5平台上尚未实现fl.adapter.getLaunchOptionsSync方法');
        return  {};
    };
    /** 获取系统信息 */
    fl.adapter.getSystemInfoSync = ()=>{
        fl.log('在H5平台上尚未实现fl.adapter.getSystemInfoSync方法');
        return  {};
    };
    // 小游戏跳转
    fl.adapter.navigateToMiniProgram = () => {};
    /** 设置屏幕常亮 */
    fl.adapter.setKeepScreenOn = (data)=>{};
    /** 显示吐司提示 */
    fl.adapter.showToast = (data) => { return fl.log('在H5平台上尚未实现fl.adapter.showToast方法', data); };




    // 广告
    /** 创建Banner广告 */
    fl.adapter.createBannerAd = (data) => {
        return new FLBanner();
    };

    /** 创建激励式视频广告 */
    fl.adapter.createRewardedVideoAd = (data) => {
        return new FLRewardedVideoAd();
    };

    /** 创建插屏广告 */
    fl.adapter.createInterstitialAd = (data) => {
        return new FLInterstitialAd(data);
    };

    /** 创建原生广告 */
    fl.adapter.createNativeAd = (data) => {
        return new FLNativeAd(data);
    };

    /** 创建盒子广告 */
    fl.adapter.createAppBox = (data) => {
        return new FLGameBoxAd(data);
    };




    fl.adapter.sendEvent = (eventID, params)=>{
        console.log("web=============");
    }

    // 转发分享
    /** 显示当前页面的转发按钮 */
    fl.adapter.showShareMenu = (data) => {};
    /** 主动拉起转发，进入选择通讯录界面 */
    fl.adapter.shareAppMessage = (data) => {};
    /** 监听用户点击右上角菜单的「转发」按钮时触发的事件 */
    fl.adapter.onShareAppMessage = (callback) => {};
    /** 更新转发属性 */
    fl.adapter.updateShareMenu = (data) => {};
    /** 获取转发详细信息 */
    fl.adapter.getShareInfo = (data) => {};




    // 跳转
    fl.adapter.onMoreGamesModalClose = ()=>{};
    fl.adapter.onNavigateToMiniProgram = ()=>{};




    // 设备
    /** 控制屏幕常亮 */
    fl.adapter.setKeepScreenOn = ()=>{};
    fl.adapter.setClipboardData = ()=>{};
    fl.adapter.getClipboardData = ()=>{};
    fl.adapter.vibrateShort = ()=>{};
    fl.adapter.vibrateLong = ()=>{};
    fl.adapter.showModal = ()=>{};
    fl.adapter.showToast = ()=>{};
}